/* 
* Copyright (c) 2006, MessageVista Communication
* All rights reserved.
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the MessageVista Communication nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY MESSAGEVISTA COMMUNICATION "AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL THE MESSAGEVISTA AND CONTRIBUTORS BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using zTexter.com.messagevista.www;

namespace MessageVista.zTexter
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class zTexterForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.TabPage tabPage2;
		private System.Windows.Forms.TabPage tabPage3;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBoxPhoneNumbers;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.TextBox textBoxTextMsg;
		private System.Windows.Forms.ToolTip toolTipHelp;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox textBoxUsername;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox textBoxPassword;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Button buttonSave;
		private System.Windows.Forms.TextBox textBoxFirstName;
		private System.Windows.Forms.TextBox textBoxLastName;
		private System.Windows.Forms.TextBox textBoxCellPhoneNumber;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Button buttonAddToBook;
		private System.Windows.Forms.ListView listViewPeople;
		private System.Windows.Forms.TextBox textBoxSenderID;
		private System.Windows.Forms.Button buttonRefresh;
		private System.Windows.Forms.Button buttonDelete;
		private System.ComponentModel.IContainer components;
		private const string sUserInfoFile = "user.ini";
		private System.Windows.Forms.Button buttonSelect;
		private const string sEncPassword = "kaadoos";
		private System.Windows.Forms.Button buttonPaste;
		private System.Windows.Forms.LinkLabel linkToSignUp;
		private System.Windows.Forms.LinkLabel linkViewReport;
		private System.Windows.Forms.Button buttonFlash;
		private System.Windows.Forms.Button buttonSend;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.ComboBox comboBoxDay;
		private System.Windows.Forms.GroupBox groupBoxSchedule;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.TextBox textBoxHours;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.TextBox textBoxMinute;
		private System.Windows.Forms.CheckBox checkBoxSchedule;
		private System.Windows.Forms.TabPage tabPage4;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.RichTextBox richTextBoxLicNotice;
		private string _sSelectedNumbers = "";
		private System.Windows.Forms.PictureBox pictureBox2;
		private const string sConstLicensNotice = 			
" Copyright (C) 2006, MessageVista Communication\r\n"+
" All rights reserved.\r\n"+
" Redistribution and use in source and binary forms, with or without\r\n"+
" modification, are permitted provided that the following conditions are met:\r\n"+
"\r\n"+
"\t* Redistributions of source code must retain the above copyright\r\n"+
"\tnotice, this list of conditions and the following disclaimer.\r\n"+
"\tRedistributions in binary form must reproduce the above copyright\r\n"+
"\tnotice, this list of conditions and the following disclaimer in the\r\n"+
"\tdocumentation and/or other materials provided with the distribution.\r\n"+
"\t* Neither the name of the MessageVista Communication nor the\r\n"+
"\tnames of its contributors may be used to endorse or promote products\r\n"+
"\tderived from this software without specific prior written permission.\r\n"+
"\r\n"+
"* THIS SOFTWARE IS PROVIDED BY MESSAGEVISTA COMMUNICATION \"AS IS\'' AND ANY\r\n"+
"* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\r\n"+
"* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\r\n"+
"* DISCLAIMED. IN NO EVENT SHALL THE MESSAGEVISTA AND CONTRIBUTORS BE LIABLE FOR ANY\r\n"+
"* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\r\n"+
"* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\r\n"+
"* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\r\n"+
"* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\r\n"+
"* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\r\n"+
"* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\r\n";

		public zTexterForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			linkToSignUp.Links.Add(0,linkToSignUp.Text.Length,"www.messagevista.com/subscribers/CreateNewAccount.aspx");
			linkViewReport.Links.Add(40,21,"www.messagevista.com/Subscribers/Login.aspx");
			richTextBoxLicNotice.Text = sConstLicensNotice;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(zTexterForm));
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.checkBoxSchedule = new System.Windows.Forms.CheckBox();
			this.groupBoxSchedule = new System.Windows.Forms.GroupBox();
			this.textBoxMinute = new System.Windows.Forms.TextBox();
			this.label14 = new System.Windows.Forms.Label();
			this.textBoxHours = new System.Windows.Forms.TextBox();
			this.label13 = new System.Windows.Forms.Label();
			this.comboBoxDay = new System.Windows.Forms.ComboBox();
			this.label12 = new System.Windows.Forms.Label();
			this.linkViewReport = new System.Windows.Forms.LinkLabel();
			this.label3 = new System.Windows.Forms.Label();
			this.buttonFlash = new System.Windows.Forms.Button();
			this.buttonSend = new System.Windows.Forms.Button();
			this.textBoxTextMsg = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.buttonPaste = new System.Windows.Forms.Button();
			this.textBoxPhoneNumbers = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.buttonSelect = new System.Windows.Forms.Button();
			this.buttonDelete = new System.Windows.Forms.Button();
			this.buttonRefresh = new System.Windows.Forms.Button();
			this.listViewPeople = new System.Windows.Forms.ListView();
			this.buttonAddToBook = new System.Windows.Forms.Button();
			this.label11 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.textBoxCellPhoneNumber = new System.Windows.Forms.TextBox();
			this.textBoxLastName = new System.Windows.Forms.TextBox();
			this.textBoxFirstName = new System.Windows.Forms.TextBox();
			this.tabPage3 = new System.Windows.Forms.TabPage();
			this.linkToSignUp = new System.Windows.Forms.LinkLabel();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.buttonSave = new System.Windows.Forms.Button();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.textBoxSenderID = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.textBoxPassword = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.textBoxUsername = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.tabPage4 = new System.Windows.Forms.TabPage();
			this.richTextBoxLicNotice = new System.Windows.Forms.RichTextBox();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.label16 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.panel1 = new System.Windows.Forms.Panel();
			this.label1 = new System.Windows.Forms.Label();
			this.toolTipHelp = new System.Windows.Forms.ToolTip(this.components);
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.tabControl1.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBoxSchedule.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.tabPage3.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.tabPage4.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabPage1);
			this.tabControl1.Controls.Add(this.tabPage2);
			this.tabControl1.Controls.Add(this.tabPage3);
			this.tabControl1.Controls.Add(this.tabPage4);
			this.tabControl1.Location = new System.Drawing.Point(8, 120);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(560, 360);
			this.tabControl1.TabIndex = 0;
			// 
			// tabPage1
			// 
			this.tabPage1.BackColor = System.Drawing.Color.RosyBrown;
			this.tabPage1.Controls.Add(this.groupBox2);
			this.tabPage1.Controls.Add(this.groupBox1);
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(552, 334);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "Send message";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.checkBoxSchedule);
			this.groupBox2.Controls.Add(this.groupBoxSchedule);
			this.groupBox2.Controls.Add(this.linkViewReport);
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.buttonFlash);
			this.groupBox2.Controls.Add(this.buttonSend);
			this.groupBox2.Controls.Add(this.textBoxTextMsg);
			this.groupBox2.Location = new System.Drawing.Point(16, 136);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(520, 192);
			this.groupBox2.TabIndex = 1;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Message text";
			// 
			// checkBoxSchedule
			// 
			this.checkBoxSchedule.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.checkBoxSchedule.Location = new System.Drawing.Point(24, 88);
			this.checkBoxSchedule.Name = "checkBoxSchedule";
			this.checkBoxSchedule.Size = new System.Drawing.Size(136, 24);
			this.checkBoxSchedule.TabIndex = 8;
			this.checkBoxSchedule.Text = "Schedule message";
			this.checkBoxSchedule.CheckedChanged += new System.EventHandler(this.OnScheduleChecked);
			// 
			// groupBoxSchedule
			// 
			this.groupBoxSchedule.Controls.Add(this.textBoxMinute);
			this.groupBoxSchedule.Controls.Add(this.label14);
			this.groupBoxSchedule.Controls.Add(this.textBoxHours);
			this.groupBoxSchedule.Controls.Add(this.label13);
			this.groupBoxSchedule.Controls.Add(this.comboBoxDay);
			this.groupBoxSchedule.Controls.Add(this.label12);
			this.groupBoxSchedule.Enabled = false;
			this.groupBoxSchedule.Location = new System.Drawing.Point(16, 112);
			this.groupBoxSchedule.Name = "groupBoxSchedule";
			this.groupBoxSchedule.Size = new System.Drawing.Size(496, 40);
			this.groupBoxSchedule.TabIndex = 7;
			this.groupBoxSchedule.TabStop = false;
			this.groupBoxSchedule.Text = "Schedule";
			// 
			// textBoxMinute
			// 
			this.textBoxMinute.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBoxMinute.Location = new System.Drawing.Point(353, 14);
			this.textBoxMinute.Name = "textBoxMinute";
			this.textBoxMinute.Size = new System.Drawing.Size(56, 20);
			this.textBoxMinute.TabIndex = 5;
			this.textBoxMinute.Text = "";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(312, 16);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(40, 16);
			this.label14.TabIndex = 4;
			this.label14.Text = "Minutes";
			// 
			// textBoxHours
			// 
			this.textBoxHours.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBoxHours.Location = new System.Drawing.Point(232, 13);
			this.textBoxHours.Name = "textBoxHours";
			this.textBoxHours.Size = new System.Drawing.Size(56, 20);
			this.textBoxHours.TabIndex = 3;
			this.textBoxHours.Text = "";
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(192, 16);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(40, 16);
			this.label13.TabIndex = 2;
			this.label13.Text = "Hours";
			// 
			// comboBoxDay
			// 
			this.comboBoxDay.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxDay.Items.AddRange(new object[] {
															 "0",
															 "1",
															 "2",
															 "3",
															 "4",
															 "5",
															 "6",
															 "7"});
			this.comboBoxDay.Location = new System.Drawing.Point(103, 12);
			this.comboBoxDay.Name = "comboBoxDay";
			this.comboBoxDay.Size = new System.Drawing.Size(73, 21);
			this.comboBoxDay.TabIndex = 1;
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(56, 15);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(40, 16);
			this.label12.TabIndex = 0;
			this.label12.Text = "Days";
			// 
			// linkViewReport
			// 
			this.linkViewReport.Location = new System.Drawing.Point(16, 160);
			this.linkViewReport.Name = "linkViewReport";
			this.linkViewReport.Size = new System.Drawing.Size(496, 29);
			this.linkViewReport.TabIndex = 6;
			this.linkViewReport.TabStop = true;
			this.linkViewReport.Text = "To view message delivery status, please login to your account and use dashboard p" +
				"age to view the report.";
			this.linkViewReport.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.OnViewReport);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 16);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(384, 16);
			this.label3.TabIndex = 5;
			this.label3.Text = "Enter your text message here  (Maximum 160 characters)";
			// 
			// buttonFlash
			// 
			this.buttonFlash.Enabled = false;
			this.buttonFlash.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonFlash.Location = new System.Drawing.Point(424, 64);
			this.buttonFlash.Name = "buttonFlash";
			this.buttonFlash.Size = new System.Drawing.Size(88, 24);
			this.buttonFlash.TabIndex = 4;
			this.buttonFlash.Text = "Flash ...";
			this.toolTipHelp.SetToolTip(this.buttonFlash, "Flash message on target cell phone(s)");
			this.buttonFlash.Click += new System.EventHandler(this.OnFlash);
			// 
			// buttonSend
			// 
			this.buttonSend.Enabled = false;
			this.buttonSend.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonSend.Location = new System.Drawing.Point(424, 32);
			this.buttonSend.Name = "buttonSend";
			this.buttonSend.Size = new System.Drawing.Size(88, 24);
			this.buttonSend.TabIndex = 3;
			this.buttonSend.Text = "Send ...";
			this.toolTipHelp.SetToolTip(this.buttonSend, "Send message to target cell phone(s)");
			this.buttonSend.Click += new System.EventHandler(this.OnSend);
			// 
			// textBoxTextMsg
			// 
			this.textBoxTextMsg.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBoxTextMsg.Location = new System.Drawing.Point(16, 32);
			this.textBoxTextMsg.MaxLength = 160;
			this.textBoxTextMsg.Multiline = true;
			this.textBoxTextMsg.Name = "textBoxTextMsg";
			this.textBoxTextMsg.Size = new System.Drawing.Size(400, 56);
			this.textBoxTextMsg.TabIndex = 0;
			this.textBoxTextMsg.Text = "";
			this.textBoxTextMsg.TextChanged += new System.EventHandler(this.OnTextMessageChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.buttonPaste);
			this.groupBox1.Controls.Add(this.textBoxPhoneNumbers);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Location = new System.Drawing.Point(16, 16);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(520, 120);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Target cell phone numbers ";
			// 
			// buttonPaste
			// 
			this.buttonPaste.Enabled = false;
			this.buttonPaste.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonPaste.Location = new System.Drawing.Point(424, 48);
			this.buttonPaste.Name = "buttonPaste";
			this.buttonPaste.Size = new System.Drawing.Size(88, 40);
			this.buttonPaste.TabIndex = 2;
			this.buttonPaste.Text = "Paste selected numbers";
			this.toolTipHelp.SetToolTip(this.buttonPaste, "Paste the selected phone numbers from address back");
			this.buttonPaste.Click += new System.EventHandler(this.OnPasteClick);
			// 
			// textBoxPhoneNumbers
			// 
			this.textBoxPhoneNumbers.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBoxPhoneNumbers.Location = new System.Drawing.Point(16, 48);
			this.textBoxPhoneNumbers.Multiline = true;
			this.textBoxPhoneNumbers.Name = "textBoxPhoneNumbers";
			this.textBoxPhoneNumbers.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBoxPhoneNumbers.Size = new System.Drawing.Size(400, 64);
			this.textBoxPhoneNumbers.TabIndex = 1;
			this.textBoxPhoneNumbers.Text = "";
			this.textBoxPhoneNumbers.TextChanged += new System.EventHandler(this.OnTargetNumbersChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(328, 16);
			this.label2.TabIndex = 0;
			this.label2.Text = "Target numbers (Please separate phone numbers by comma)";
			// 
			// tabPage2
			// 
			this.tabPage2.BackColor = System.Drawing.Color.RosyBrown;
			this.tabPage2.Controls.Add(this.buttonSelect);
			this.tabPage2.Controls.Add(this.buttonDelete);
			this.tabPage2.Controls.Add(this.buttonRefresh);
			this.tabPage2.Controls.Add(this.listViewPeople);
			this.tabPage2.Controls.Add(this.buttonAddToBook);
			this.tabPage2.Controls.Add(this.label11);
			this.tabPage2.Controls.Add(this.label10);
			this.tabPage2.Controls.Add(this.label9);
			this.tabPage2.Controls.Add(this.textBoxCellPhoneNumber);
			this.tabPage2.Controls.Add(this.textBoxLastName);
			this.tabPage2.Controls.Add(this.textBoxFirstName);
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(552, 334);
			this.tabPage2.TabIndex = 1;
			this.tabPage2.Text = "Address book";
			// 
			// buttonSelect
			// 
			this.buttonSelect.Enabled = false;
			this.buttonSelect.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonSelect.Location = new System.Drawing.Point(232, 80);
			this.buttonSelect.Name = "buttonSelect";
			this.buttonSelect.Size = new System.Drawing.Size(120, 23);
			this.buttonSelect.TabIndex = 10;
			this.buttonSelect.Text = "Select to send SMS";
			this.buttonSelect.Click += new System.EventHandler(this.OnSelect);
			// 
			// buttonDelete
			// 
			this.buttonDelete.Enabled = false;
			this.buttonDelete.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonDelete.Location = new System.Drawing.Point(453, 80);
			this.buttonDelete.Name = "buttonDelete";
			this.buttonDelete.TabIndex = 9;
			this.buttonDelete.Text = "Delete ...";
			this.toolTipHelp.SetToolTip(this.buttonDelete, "Delete the entry from phone book table");
			this.buttonDelete.Click += new System.EventHandler(this.OnDeletePhoneEntry);
			// 
			// buttonRefresh
			// 
			this.buttonRefresh.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonRefresh.Location = new System.Drawing.Point(368, 80);
			this.buttonRefresh.Name = "buttonRefresh";
			this.buttonRefresh.TabIndex = 8;
			this.buttonRefresh.Text = "Refresh";
			this.toolTipHelp.SetToolTip(this.buttonRefresh, "Reload the phone book table");
			this.buttonRefresh.Click += new System.EventHandler(this.OnRefresh);
			// 
			// listViewPeople
			// 
			this.listViewPeople.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.listViewPeople.Location = new System.Drawing.Point(24, 112);
			this.listViewPeople.Name = "listViewPeople";
			this.listViewPeople.Size = new System.Drawing.Size(504, 208);
			this.listViewPeople.TabIndex = 7;
			this.listViewPeople.SelectedIndexChanged += new System.EventHandler(this.OnSelectedChanged);
			// 
			// buttonAddToBook
			// 
			this.buttonAddToBook.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonAddToBook.Location = new System.Drawing.Point(394, 36);
			this.buttonAddToBook.Name = "buttonAddToBook";
			this.buttonAddToBook.Size = new System.Drawing.Size(134, 20);
			this.buttonAddToBook.TabIndex = 6;
			this.buttonAddToBook.Text = "Add to book ...";
			this.toolTipHelp.SetToolTip(this.buttonAddToBook, "Add the new contact info to address book");
			this.buttonAddToBook.Click += new System.EventHandler(this.OnAdd);
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(266, 16);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(72, 16);
			this.label11.TabIndex = 5;
			this.label11.Text = "Cell phone";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(146, 16);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(72, 16);
			this.label10.TabIndex = 4;
			this.label10.Text = "Last name";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(26, 16);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(72, 16);
			this.label9.TabIndex = 3;
			this.label9.Text = "First name";
			// 
			// textBoxCellPhoneNumber
			// 
			this.textBoxCellPhoneNumber.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBoxCellPhoneNumber.Location = new System.Drawing.Point(266, 36);
			this.textBoxCellPhoneNumber.MaxLength = 20;
			this.textBoxCellPhoneNumber.Name = "textBoxCellPhoneNumber";
			this.textBoxCellPhoneNumber.TabIndex = 2;
			this.textBoxCellPhoneNumber.Text = "";
			// 
			// textBoxLastName
			// 
			this.textBoxLastName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBoxLastName.Location = new System.Drawing.Point(146, 36);
			this.textBoxLastName.MaxLength = 20;
			this.textBoxLastName.Name = "textBoxLastName";
			this.textBoxLastName.TabIndex = 1;
			this.textBoxLastName.Text = "";
			// 
			// textBoxFirstName
			// 
			this.textBoxFirstName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBoxFirstName.Location = new System.Drawing.Point(26, 36);
			this.textBoxFirstName.MaxLength = 15;
			this.textBoxFirstName.Name = "textBoxFirstName";
			this.textBoxFirstName.TabIndex = 0;
			this.textBoxFirstName.Text = "";
			// 
			// tabPage3
			// 
			this.tabPage3.BackColor = System.Drawing.Color.RosyBrown;
			this.tabPage3.Controls.Add(this.linkToSignUp);
			this.tabPage3.Controls.Add(this.groupBox3);
			this.tabPage3.Location = new System.Drawing.Point(4, 22);
			this.tabPage3.Name = "tabPage3";
			this.tabPage3.Size = new System.Drawing.Size(552, 334);
			this.tabPage3.TabIndex = 2;
			this.tabPage3.Text = "Account settings";
			// 
			// linkToSignUp
			// 
			this.linkToSignUp.Location = new System.Drawing.Point(272, 296);
			this.linkToSignUp.Name = "linkToSignUp";
			this.linkToSignUp.Size = new System.Drawing.Size(256, 23);
			this.linkToSignUp.TabIndex = 1;
			this.linkToSignUp.TabStop = true;
			this.linkToSignUp.Text = "Click here if you have not created an account yet.";
			this.linkToSignUp.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.linkToSignUp.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.OnLinkClicked);
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.buttonSave);
			this.groupBox3.Controls.Add(this.label8);
			this.groupBox3.Controls.Add(this.label7);
			this.groupBox3.Controls.Add(this.textBoxSenderID);
			this.groupBox3.Controls.Add(this.label6);
			this.groupBox3.Controls.Add(this.textBoxPassword);
			this.groupBox3.Controls.Add(this.label5);
			this.groupBox3.Controls.Add(this.textBoxUsername);
			this.groupBox3.Controls.Add(this.label4);
			this.groupBox3.Location = new System.Drawing.Point(16, 16);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(520, 160);
			this.groupBox3.TabIndex = 0;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Already have an account with MessageVista?";
			// 
			// buttonSave
			// 
			this.buttonSave.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonSave.Location = new System.Drawing.Point(416, 32);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.Size = new System.Drawing.Size(88, 32);
			this.buttonSave.TabIndex = 8;
			this.buttonSave.Text = "Save ...";
			this.toolTipHelp.SetToolTip(this.buttonSave, "Save the settings");
			this.buttonSave.Click += new System.EventHandler(this.OnSaveAccountInfo);
			// 
			// label8
			// 
			this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label8.Location = new System.Drawing.Point(16, 136);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(480, 16);
			this.label8.TabIndex = 7;
			this.label8.Text = "Note: Message delivery to some mobile networks will fail if SenderID is not numer" +
				"ic.";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(254, 100);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(192, 16);
			this.label7.TabIndex = 6;
			this.label7.Text = "(Max 16 alphanumeric characters)";
			// 
			// textBoxSenderID
			// 
			this.textBoxSenderID.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBoxSenderID.Location = new System.Drawing.Point(109, 96);
			this.textBoxSenderID.Name = "textBoxSenderID";
			this.textBoxSenderID.Size = new System.Drawing.Size(139, 20);
			this.textBoxSenderID.TabIndex = 5;
			this.textBoxSenderID.Text = "";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(14, 100);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(88, 16);
			this.label6.TabIndex = 4;
			this.label6.Text = "SenderID";
			// 
			// textBoxPassword
			// 
			this.textBoxPassword.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBoxPassword.Location = new System.Drawing.Point(109, 63);
			this.textBoxPassword.Name = "textBoxPassword";
			this.textBoxPassword.PasswordChar = 'x';
			this.textBoxPassword.Size = new System.Drawing.Size(139, 20);
			this.textBoxPassword.TabIndex = 3;
			this.textBoxPassword.Text = "";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(14, 66);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(88, 16);
			this.label5.TabIndex = 2;
			this.label5.Text = "Enter password";
			// 
			// textBoxUsername
			// 
			this.textBoxUsername.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textBoxUsername.Location = new System.Drawing.Point(109, 29);
			this.textBoxUsername.Name = "textBoxUsername";
			this.textBoxUsername.Size = new System.Drawing.Size(139, 20);
			this.textBoxUsername.TabIndex = 1;
			this.textBoxUsername.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(14, 32);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(88, 16);
			this.label4.TabIndex = 0;
			this.label4.Text = "Enter username";
			// 
			// tabPage4
			// 
			this.tabPage4.BackColor = System.Drawing.Color.White;
			this.tabPage4.Controls.Add(this.richTextBoxLicNotice);
			this.tabPage4.Controls.Add(this.pictureBox1);
			this.tabPage4.Controls.Add(this.label16);
			this.tabPage4.Controls.Add(this.label15);
			this.tabPage4.Location = new System.Drawing.Point(4, 22);
			this.tabPage4.Name = "tabPage4";
			this.tabPage4.Size = new System.Drawing.Size(552, 334);
			this.tabPage4.TabIndex = 3;
			this.tabPage4.Text = "About";
			// 
			// richTextBoxLicNotice
			// 
			this.richTextBoxLicNotice.BackColor = System.Drawing.SystemColors.Info;
			this.richTextBoxLicNotice.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.richTextBoxLicNotice.Location = new System.Drawing.Point(16, 120);
			this.richTextBoxLicNotice.Name = "richTextBoxLicNotice";
			this.richTextBoxLicNotice.Size = new System.Drawing.Size(520, 200);
			this.richTextBoxLicNotice.TabIndex = 7;
			this.richTextBoxLicNotice.Text = "richTextBox1";
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(16, 24);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(232, 64);
			this.pictureBox1.TabIndex = 6;
			this.pictureBox1.TabStop = false;
			// 
			// label16
			// 
			this.label16.Font = new System.Drawing.Font("Verdana", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label16.Location = new System.Drawing.Point(264, 48);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(272, 56);
			this.label16.TabIndex = 1;
			this.label16.Text = "A utility to send mobile short messages using MessageVista Communication gateway." +
				"";
			// 
			// label15
			// 
			this.label15.Font = new System.Drawing.Font("Verdana", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label15.ForeColor = System.Drawing.SystemColors.WindowText;
			this.label15.Location = new System.Drawing.Point(264, 24);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(184, 24);
			this.label15.TabIndex = 0;
			this.label15.Text = "zTexter - Version 1.0";
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel1.Controls.Add(this.pictureBox2);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(560, 104);
			this.panel1.TabIndex = 1;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("PosterBodoni BT", 14.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.DimGray;
			this.label1.Location = new System.Drawing.Point(248, 13);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(304, 80);
			this.label1.TabIndex = 1;
			this.label1.Text = "Send short messages from your desktop to any cell phones worldwide!";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// pictureBox2
			// 
			this.pictureBox2.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox2.Image")));
			this.pictureBox2.Location = new System.Drawing.Point(8, 16);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(232, 64);
			this.pictureBox2.TabIndex = 7;
			this.pictureBox2.TabStop = false;
			// 
			// zTexterForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(576, 504);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.tabControl1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "zTexterForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "zTexter - Your desktop text messaging tool";
			this.Load += new System.EventHandler(this.OnLoad);
			this.tabControl1.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBoxSchedule.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.tabPage3.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.tabPage4.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new zTexterForm());
		}


		#region Private methods
		private void InitPhoneBookListView()
		{
			listViewPeople.View = View.Details;
			listViewPeople.FullRowSelect = true;
			listViewPeople.HideSelection = false;
			listViewPeople.Columns.Add("Order",65,System.Windows.Forms.HorizontalAlignment.Left);
			listViewPeople.Columns.Add("First name",90,System.Windows.Forms.HorizontalAlignment.Left);
			listViewPeople.Columns.Add("Last name",90,System.Windows.Forms.HorizontalAlignment.Left);
			listViewPeople.Columns.Add("Cell number",90,System.Windows.Forms.HorizontalAlignment.Left);
		}

		private void LoadUserInfo()
		{
			Security.Security sec = new MessageVista.Security.Security();
			System.IO.StreamReader sr = null;

			try
			{
				sr = new System.IO.StreamReader(System.IO.Path.GetDirectoryName(Application.ExecutablePath) + "\\" + sUserInfoFile);
				string sInfo = sr.ReadToEnd();

				if( sInfo != null && sInfo.Trim().Length > 0 )
				{
					string[] items = sInfo.Split("|".ToCharArray());

					if( items != null && items.Length == 3 )
					{
						textBoxUsername.Text = items[0];
						textBoxPassword.Text = sec.Decrypt(items[1],sEncPassword);
						textBoxSenderID.Text = items[2];
					}
				}
			}
			catch( Exception e )
			{
				MessageBox.Show( e.Message, "Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
		}

		private bool AreScheduleEntriesValid(ref int iTotal, out string sErrorMsg)
		{
			sErrorMsg = "";
			string sDays = comboBoxDay.Text;
			string sHours = textBoxHours.Text.Trim();
			string sMinutes = textBoxMinute.Text.Trim();

			try
			{
				int iDays = Convert.ToInt32(sDays == "" ? "0" : sDays);
				int iHours = Convert.ToInt32(sHours == "" ? "0" : sHours);
				int iMinutes = Convert.ToInt32(sMinutes == "" ? "0" : sMinutes);
				iTotal = iDays * 24 * 60 + iHours * 60 + iMinutes;
				
				if( iTotal > 7 * 24 * 60 )
				{					
					sErrorMsg = "Total scheduled time exceeds one week or 10800 minutes.";
					return false;
				}		
				else if( iTotal == 0 )
				{
					iTotal = -1;
				}
			}
			catch( Exception e )
			{
				sErrorMsg = e.Message;
				return false;
			}
			return true;
		}

		private void OnAdd(object sender, System.EventArgs e)
		{
			GatewayAPI api = new GatewayAPI();
			string sErr;
			
			for( int ee = 0 ; ee < textBoxCellPhoneNumber.Text.Trim().Length ; ee++ )
			{
				if( !char.IsNumber(textBoxCellPhoneNumber.Text.Trim()[ee]) )
				{
					MessageBox.Show(
					"The cell phone number that you have entered has an invalid format. Please just enter country code, city code and the phone number like 14161231234.",
						"Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
					return;
				}
			}

			if( !api.InsertToAddressBook(textBoxUsername.Text.Trim(),
				textBoxFirstName.Text.Trim(),
				textBoxLastName.Text.Trim(),
				textBoxCellPhoneNumber.Text.Trim(),
				out sErr) )
			{
				MessageBox.Show( "Unable to add the new entry to the phone book.",
					"Note", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			else
			{
				AddEntryToListView(textBoxFirstName.Text.Trim(),textBoxLastName.Text.Trim(),textBoxCellPhoneNumber.Text.Trim());
				MessageBox.Show("The entry has been added to the phone book successfully.",
					"Note",MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
		}

		private void AddEntryToListView(string sFirstName,string sLastName,string sCellNumber)
		{
			ListViewItem lv = new ListViewItem((listViewPeople.Items.Count+1).ToString());
			lv.SubItems.Add(sFirstName);
			lv.SubItems.Add(sLastName);
			lv.SubItems.Add(sCellNumber);
			listViewPeople.Items.Add(lv);
		}

		#endregion

		#region Event handlers
		private void OnLoad(object sender, System.EventArgs e)
		{
			LoadUserInfo();
			InitPhoneBookListView();
			GatewayAPI api = new GatewayAPI();
			string sErr;
			string sEntries = api.RetrieveAdressBook(textBoxUsername.Text.Trim(), out sErr );

			if( sEntries != null && sEntries.Trim().Length > 0)
			{
				string[] sChunks = sEntries.TrimEnd(new char[]{'|'}).Split(new char[]{'|'});

				for( int u = 0; u < sChunks.Length; u++ )
				{
					string[] sColumns = sChunks[u].Split(new char[]{','});
					ListViewItem lv = new ListViewItem((u+1).ToString());

					for( int s =0 ; s < sColumns.Length; s++ )
					{						
						lv.SubItems.Add(sColumns[s]);
					}

					listViewPeople.Items.Add(lv);
				}
			}
		}

		private void OnSelectedChanged(object sender, System.EventArgs e)
		{
			buttonDelete.Enabled = listViewPeople.SelectedItems.Count > 0;
			buttonSelect.Enabled = listViewPeople.SelectedItems.Count > 0;
		}

		private void OnRefresh(object sender, System.EventArgs e)
		{
			listViewPeople.Items.Clear();
			listViewPeople.Columns.Clear();
			OnLoad(sender,e);
		}

		private void OnDeletePhoneEntry(object sender, System.EventArgs e)
		{
			if( MessageBox.Show("The selected entries will be deleted permanently, are you sure that you want to proceed?",
				"Warning",MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No )
			{
				return;
			}

			GatewayAPI api = new GatewayAPI();

			for( int u = listViewPeople.SelectedIndices.Count - 1; u >= 0 ; u-- )
			{
				string sCellNumber = listViewPeople.Items[ listViewPeople.SelectedIndices[u] ].SubItems[3].Text;
				string sErr;

				if( textBoxUsername.Text.Trim().Length > 0 )
				{
					if( api.DeleteFromAddressBook(textBoxUsername.Text.Trim(), sCellNumber, out sErr ) )
					{
						listViewPeople.Items.RemoveAt(listViewPeople.SelectedIndices[u]);
					}
				}
				else
				{
					MessageBox.Show("Please enter your username in the designated box.",
						"Note", MessageBoxButtons.OK, MessageBoxIcon.Warning);
					return;
				}
			}
		}

		private void OnSaveAccountInfo(object sender, System.EventArgs e)
		{
			Security.Security sec = new MessageVista.Security.Security();
			string sSaveToHDD = "{0}|{1}|{2}";
			sSaveToHDD = string.Format(sSaveToHDD,
				textBoxUsername.Text,
				sec.Encrypt(textBoxPassword.Text,sEncPassword),
				textBoxSenderID.Text);
			System.IO.StreamWriter sw = null;

			try
			{
				sw = new System.IO.StreamWriter(System.IO.Path.GetDirectoryName( Application.ExecutablePath ) + "\\" + sUserInfoFile,false);
				sw.Write(sSaveToHDD);
				sw.Flush();
				sw.Close();
				MessageBox.Show("Your account infomration has been saved successfully.","Information",MessageBoxButtons.OK,MessageBoxIcon.Information);
			}
			catch( Exception ex )
			{
				MessageBox.Show( ex.Message,"Error",MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void OnSelect(object sender, System.EventArgs e)
		{
			_sSelectedNumbers = "";

			for( int u = listViewPeople.SelectedIndices.Count - 1; u >= 0 ; u-- )
			{
				string sCellNumber = listViewPeople.Items[ listViewPeople.SelectedIndices[u] ].SubItems[3].Text;
				_sSelectedNumbers += sCellNumber;
				_sSelectedNumbers += ",";
			}

			buttonPaste.Enabled = _sSelectedNumbers.Trim().Length > 0;			
		}

		private void OnPasteClick(object sender, System.EventArgs e)
		{
			textBoxPhoneNumbers.Text += textBoxPhoneNumbers.Text.Trim().Length == 0 ?
			_sSelectedNumbers.TrimEnd(',') : ","+_sSelectedNumbers.TrimEnd(',');
		}

		private void OnLinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start(e.Link.LinkData as string);
		}

		private void OnViewReport(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start(e.Link.LinkData as string);
		}

		private void OnSend(object sender, System.EventArgs e)
		{
			GatewayAPI api = new GatewayAPI();
			int iElapsedTime = -1,
				iErrorCode;
			string sErrorMsg = "",
				sResponse;

			if( checkBoxSchedule.Checked )
			{
				if( !AreScheduleEntriesValid(ref iElapsedTime, out sErrorMsg ) )
				{
					MessageBox.Show( sErrorMsg , "Note", MessageBoxButtons.OK, MessageBoxIcon.Error);
					return;
				}
			}
			
			if( !api.SendShortMessage(textBoxUsername.Text,
				textBoxPassword.Text,
				DateTime.Now,
				textBoxTextMsg.Text,
				textBoxPhoneNumbers.Text,
				textBoxSenderID.Text,
				iElapsedTime,
				Guid.NewGuid().ToString().Substring(0,32).Trim(new char[]{'-'}),
				out sResponse,
				out sErrorMsg,
				out iErrorCode) )
			{
				MessageBox.Show( sErrorMsg , "Note", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			else
			{
				MessageBox.Show( 
					"Your text message has been submitted to MessageVista's gateway to be delivered to target numbers.",
					"Note", 
					MessageBoxButtons.OK, 
					MessageBoxIcon.Information );
			}
		}

		private void OnFlash(object sender, System.EventArgs e)
		{
			GatewayAPI api = new GatewayAPI();
			int iElapsedTime = -1,
				iErrorCode;
			string sErrorMsg = "",
				sResponse;

			if( checkBoxSchedule.Checked )
			{
				if( !AreScheduleEntriesValid(ref iElapsedTime, out sErrorMsg ) )
				{
					MessageBox.Show( sErrorMsg , "Note", MessageBoxButtons.OK, MessageBoxIcon.Error);
					return;
				}
			}
			
			if( !api.FlashShortMessage(textBoxUsername.Text,
				textBoxPassword.Text,
				DateTime.Now,
				textBoxTextMsg.Text,
				textBoxPhoneNumbers.Text,
				textBoxSenderID.Text,
				iElapsedTime,
				Guid.NewGuid().ToString().Substring(0,32).Trim(new char[]{'-'}),
				out sResponse,
				out sErrorMsg,
				out iErrorCode) )
			{
				MessageBox.Show( sErrorMsg , "Note", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			else
			{
				MessageBox.Show( 
					"Your text message has been submitted to MessageVista's gateway to be delivered to target numbers.",
					"Note", 
					MessageBoxButtons.OK, 
					MessageBoxIcon.Information );
			}
		}

		private void OnTargetNumbersChanged(object sender, System.EventArgs e)
		{
			buttonFlash.Enabled = textBoxPhoneNumbers.Text.Trim().Length > 0 && textBoxTextMsg.Text.Trim().Length > 0;
			buttonSend.Enabled = textBoxPhoneNumbers.Text.Trim().Length > 0 && textBoxTextMsg.Text.Trim().Length > 0;
		}

		private void OnTextMessageChanged(object sender, System.EventArgs e)
		{
			buttonFlash.Enabled = textBoxPhoneNumbers.Text.Trim().Length > 0 && textBoxTextMsg.Text.Trim().Length > 0;
			buttonSend.Enabled = textBoxPhoneNumbers.Text.Trim().Length > 0 && textBoxTextMsg.Text.Trim().Length > 0;		
		}

		private void OnScheduleChecked(object sender, System.EventArgs e)
		{
			groupBoxSchedule.Enabled = checkBoxSchedule.Checked;
		}
		#endregion
	}
}
